<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="p-4">

  <app-breadcrumbs [forceReload]="tenantId"></app-breadcrumbs>

  <div
    id="folderManagementTitle"
    class="h3"
    [innerHTML]="messages.FOLDER_MANAGEMENT">
  </div>

  <!-- Header -->

  <div class="mt-3 w-100 bg-white p-2 shadow-sm">
    <fa-icon
      class="pointer text-primary"
      [icon]="isCollapsed ? plusSquareIcon : minusSquareIcon"
      (click)="isCollapsed = !isCollapsed"
      [fixedWidth]="true">
    </fa-icon>
    <span
      class="fw-bold ms-2"
      [innerText]="messages.SEARCH">
    </span>
    <div
      class="w-100"
      [ngClass]="{'collapse': isCollapsed}">
      <div class="d-flex flex-row ls-form mt-2 w-100">
        <div class="w-100 p-2">
          <div class="form-group">
            <label
              for="type-selector"
              [innerText]="commonMessages.TYPE">
            </label>
            <app-type-selector
              id="type-selector"
              [mandatory]="false"
              [tenantId]="tenantId"
              [retrieveTypesFunction]="retrieveTypesAsAdminFn"
              [(type)]="selectedType"
              (typeChange)="onTypeSelectionChanged()">
            </app-type-selector>
          </div>
          <div class="form-group">
            <label
              for="subtype-selector"
              [innerText]="commonMessages.SUBTYPE">
            </label>
            <app-subtype-selector
              id="subtype-selector"
              [mandatory]="false"
              [retrieveSubtypesFunction]="retrieveSubtypesAsAdminFn"
              [tenantId]="tenantId"
              [type]="selectedType"
              [(subtype)]="selectedSubtype">
            </app-subtype-selector>
          </div>
        </div>

        <div class="w-100 p-2">
          <div class="form-group">
            <label
              for="still-since-date"
              [innerText]="commonMessages.DESK">
            </label>
            <app-desk-search-input
              [(desks)]="deskList"
              [multiple]="false"
              [clearable]="true"
              [tenantId]="tenantId"
              [genericValidatorsAvailable]="false"
              [retrieveDeskFunction]="retrieveDesksAsAdminFn">
            </app-desk-search-input>
          </div>
          <div class="form-group">
            <label
              for="title-search"
              [innerText]="messages.FOLDER_TITLE">
            </label>
            <app-search-bar
              *ngIf="showFolderSearchBar"
              id="title-search"
              (debouncedKeyup)="updateSearchTerm($event)"
              [placeholder]="messages.SEARCH_FOLDERS">
            </app-search-bar>
          </div>
        </div>

        <div class="w-100 p-2">
          <div class="form-group">
            <label for="emit-before-date">
              {{ messages.START_DATE_BEFORE }}
              <fa-icon
                class="ps-1"
                [icon]="commonIcons.TOOLTIP_ICON"
                [ngbTooltip]="messages.START_DATE_BEFORE_TOOLTIP"
                openDelay="300">
              </fa-icon>
            </label>
            <input
              id="emit-before-date"
              class="form-control"
              name="limit-date"
              type="date"
              [(ngModel)]="emitBefore">
          </div>
          <div class="form-group">
            <label for="still-since-date">
              {{ messages.STILL_SINCE }}
              <fa-icon
                class="ps-1"
                [icon]="commonIcons.TOOLTIP_ICON"
                [ngbTooltip]="messages.STILL_SINCE_TOOLTIP"
                openDelay="300">
              </fa-icon>
            </label>
            <input
              id="still-since-date"
              class="form-control"
              name="limit-date"
              type="date"
              [(ngModel)]="stillSince">
          </div>
          <div class="form-group">
            <label
              for="pending-filter"
              [innerText]="messages.PENDING_FILTER_LABEL">
            </label>
            <ng-select
              id="pending-filter"
              [clearable]="true"
              [(ngModel)]="stateFilter"
              [placeholder]="messages.PENDING_FILTER_PLACEHOLDER">
              <ng-option
                [value]="stateEnum.Pending"
                [innerText]="messages.ONLY_PENDING_LABEL">
              </ng-option>
              <ng-option
                [value]="stateEnum.Late"
                [innerText]="messages.ONLY_LATE_LABEL">
              </ng-option>
            </ng-select>
          </div>
        </div>
      </div>
      <div class="w-100 p-2 d-flex flex-row-reverse">
        <button
          ls-button
          class="me-2"
          [text]="commonMessages.SEARCH"
          [icon]="commonIcons.SEARCH_ICON"
          (click)="refreshFolderList()">
        </button>
        <button
          ls-button
          class="me-2"
          [text]="messages.RESET_SEARCH"
          [icon]="commonIcons.RE_INIT_ICON"
          [style]="styles.NEUTRAL"
          (click)="resetSearch()">
        </button>
      </div>
    </div>
  </div>

  <!-- List -->

  <div class="pt-3 d-flex">
    <span class="flex-grow-1"></span>
    <span
      class="p-1 px-2"
      [innerHTML]="commonMessages.PAGINATION_SIZE_LABEL">
    </span>
    <ngb-pagination
      size="sm"
      class="me-2"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="refreshFolderList()">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>

    <!--    <fa-icon *ngIf="show52Features"-->
    <!--             [icon]="cogIcon"-->
    <!--             [ngbTooltip]="commonMessages.TABLE_LAYOUT_COG_TOOLTIP"-->
    <!--             (click)="openTableLayoutModal()"-->
    <!--             class="float-end pointer text-primary">-->
    <!--    </fa-icon>-->
  </div>

  <table
    *ngIf="userPreferences"
    aria-labelledby="folderManagementTitle"
    class="bg-white mt-4 table table-fixed table-striped table-borderless border shadow-sm w-100 table-text-overflow">
    <thead class="border">
      <tr>
        <ng-container *ngFor="let column of usedColumns">
          <th
            *ngIf="showIdColumn(column)"
            (click)="onRowOrderClicked(column)"
            [ngClass]="{
              'col-state-fixed-size' : column.id === columnsEnum.State,
              'col-id-fixed-size' : column.id === columnsEnum.TaskId || column.id === columnsEnum.FolderId,
              'col-date-fixed-size' : column.id === columnsEnum.LimitDate,
              'col-date-time-fixed-size' : column.id === columnsEnum.CreationDate || column.id === 'LAST_MODIFICATION_DATE',
              'pointer' : mapColumnToSortBy(column) !== null
            }"
            class="th-sm">
            <fa-icon
              *ngIf="mapColumnToSortBy(column) !== null"
              [fixedWidth]="true"
              [icon]="asc ? caretUp : caretDown"
              class="{{ sortBy === mapColumnToSortBy(column) ? 'visible' : 'invisible' }}">
            </fa-icon>
            {{ column.type === columnTypeEnum.Metadata ? column.metadata?.name : column.id | columnNamePipe }}
          </th>
        </ng-container>

        <th
          [innerText]="commonMessages.ACTIONS"
          class="th-sm col-action-fixed-size"
          scope="col">
        </th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let folder of folders">
        <td
          *ngFor="let column of usedColumns">
          <div
            *ngIf="column.id === columnsEnum.State"
            [innerText]="folder.state | stateName :false">
          </div>
          <div
            *ngIf="column.id === columnsEnum.FolderName"
            class="sortable-row overflow-hidden text-overflow-ellipsis"
            openDelay="300"
            [ngbTooltip]="folder.name | namePipe"
            [innerText]="folder.name | namePipe">
          </div>
          <div
            *ngIf="column.id === columnsEnum.Type"
            [innerText]="folder.type?.name | namePipe">
          </div>
          <div
            *ngIf="column.id === columnsEnum.Subtype"
            [innerText]="folder.subtype?.name | namePipe">
          </div>
          <div
            *ngIf="column.id === columnsEnum.CreationDate"
            class="sortable-row"
            [innerText]="folder.draftCreationDate | date: 'short'">
          </div>
          <div
            *ngIf="column.id === 'LAST_MODIFICATION_DATE'"
            class="sortable-row"
            [innerText]="folder.stepList[0].beginDate | date: 'short'">
          </div>
          <div
            *ngIf="column.id === columnsEnum.LimitDate"
            [innerText]="folder.dueDate | date: 'shortDate'"
            [ngClass]="{ 'text-danger': isDateBeforeNow(folder.dueDate) }">
          </div>
          <div
            class="overflow-hidden text-overflow-ellipsis"
            *ngIf="column.id === columnsEnum.OriginDesk"
            openDelay="300"
            [ngbTooltip]="folder.originDesk?.name | namePipe"
            [innerText]="folder.originDesk?.name | namePipe">
          </div>
          <div
            class="overflow-hidden text-overflow-ellipsis"
            *ngIf="column.id === columnsEnum.CurrentDesk">
            <span
              *ngFor="let desk of folder.stepList[0].desks"
              openDelay="300"
              [ngbTooltip]="desk.name | namePipe"
              [innerText]="desk.name | namePipe">
            </span>
          </div>
          <div
            *ngIf="column.id === columnsEnum.TaskId && showIdColumn(column)"
            class="font-monospace text-size-small"
            [innerText]="folder.stepList[0].id">
          </div>
          <div
            *ngIf="column.id === columnsEnum.FolderId && showIdColumn(column)"
            class="sortable-row font-monospace text-size-small"
            [innerText]="folder.id">
          </div>
          <div
            *ngIf="column.type === columnTypeEnum.Metadata && show52Features"
            [innerText]="folder.metadata[column.metadata.key] ?? ''">
          </div>
        </td>
        <td class="d-flex">
          <button
            ls-button
            class="me-2"
            [style]="styles.DANGER"
            [ngbTooltip]="actionsEnum.Delete | actionName"
            [icon]="actionsEnum.Delete | actionIcon"
            (click)="onDeleteButtonClicked(folder)">
          </button>
          <button
            ls-button
            class="me-2"
            [style]="styles.NEUTRAL"
            [ngbTooltip]="secondaryActionsEnum.HistoryTasks | actionName"
            [icon]="secondaryActionsEnum.HistoryTasks | actionIcon"
            (click)="onHistoryButtonClicked(folder)">
          </button>
          <div
            [tooltipClass]="'big-tooltip'"
            container="body"
            [ngbTooltip]="isTransferAvailable(folder) ? (actionsEnum.Transfer | actionName) : disabledTransferTooltip">
            <button
              ls-button
              [disabled]="!isTransferAvailable(folder)"
              [icon]="actionsEnum.Transfer | actionIcon"
              (click)="transfer(folder)">
            </button>
          </div>
        </td>
      </tr>
    </tbody>
    <tbody
      app-list-loader
      [data]="folders"
      [loading]="loading"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_FOLDER_LIST">
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="refreshFolderList()">
  </ngb-pagination>

</div>

<ng-template #disabledTransferTooltip>
  <div
    class="tooltip-min-width d-flex flex-column text-start"
    [innerHTML]="messages.TRANSFER_DISABLED">
  </div>
</ng-template>
